///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartFTP  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartFTPWrap.h SmartFTPWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartFTPCore.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartFTPWrap.h"

CSmartFTPWrap::CSmartFTPWrap(void)
{
	m_hInst = LoadLibrary(L"SmartFTPCore.dll");

    if(m_hInst == NULL)
	{
        return;
	}


	// ̽ ȹ  (̽ νϽ óѴ.)
	m_pfSetConnectInfo = (SetConnectInfoEx)GetProcAddress(m_hInst, _T("SetConnectInfo"));
	m_pfConnect = (ConnectEx)GetProcAddress(m_hInst, _T("Connect"));
	m_pfDisConnect = (DisConnectEx)GetProcAddress(m_hInst, _T("DisConnect"));
	m_pfSetRootDirectory = (SetRootDirectoryEx)GetProcAddress(m_hInst, _T("SetRootDirectory"));
	m_pfSetCurrentDirectory = (SetCurrentDirectoryEx)GetProcAddress(m_hInst, _T("SetCurrentDirectory"));
	m_pfGetCurrentDirectory = (GetCurrentDirectoryEx)GetProcAddress(m_hInst, _T("GetCurrentDirectory"));
	m_pfCreateFolder = (CreateFolderEx)GetProcAddress(m_hInst, _T("CreateFolder"));
	m_pfDeleteFolder = (DeleteFolderEx)GetProcAddress(m_hInst, _T("DeleteFolder"));
	m_pfDeleteFiles = (DeleteFilesEx)GetProcAddress(m_hInst, _T("DeleteFiles"));
	m_pfReName = (ReNameEx)GetProcAddress(m_hInst, _T("ReName"));
	m_pfFileDownload = (FileDownloadEx)GetProcAddress(m_hInst, _T("FileDownload"));
	m_pfFileUpload = (FileUploadEx)GetProcAddress(m_hInst, _T("FileUpload"));
	m_pfGetFileList = (GetFileListEx)GetProcAddress(m_hInst, _T("GetFileList"));
	m_pfGetPercentage = (GetPercentageEx)GetProcAddress(m_hInst, _T("GetPercentage"));
	m_pfFileUpNDownloadCancel = (FileUpNDownloadCancelEx)GetProcAddress(m_hInst, _T("FileUpNDownloadCancel"));
}

CSmartFTPWrap::~CSmartFTPWrap(void)
{
	FreeLibrary(m_hInst);
}

// FTP  ӿ ʿ   մϴ.
// [ ] 
// LPTSTR strFtpAddress : FTP ּ (URL or IP)
// unsigned int iPortNo : Ʈ ȣ
// LPTSTR strUserID :   
// LPTSTR strPassword :  ȣ
// BOOL bPassiveMode : PassiveMode  (True : PassiveMode , True : PassiveMode  ) 
void CSmartFTPWrap::SetConnectInfo(LPTSTR strFtpAddress, unsigned int iPortNo, LPTSTR strUserID, LPTSTR strPassword, BOOL bPassiveMode)
{
	m_pfSetConnectInfo(strFtpAddress, iPortNo, strUserID, strPassword, bPassiveMode);
}

//     
// [Return ] True :  , False :  
BOOL CSmartFTPWrap::Connect()
{
	return m_pfConnect();
}

//  
// [Return ] True :   , False :   
BOOL CSmartFTPWrap::DisConnect()
{
	return m_pfDisConnect();
}

//  θ Root 丮  մϴ.
// [Return ] True : , False : 
BOOL CSmartFTPWrap::SetRootDirectory()
{
	return m_pfSetRootDirectory();
}

//  θ  մϴ.
// [Return ] True : , False : 
BOOL CSmartFTPWrap::SetCurrentDirectory(LPTSTR strPath)
{
	return m_pfSetCurrentDirectory(strPath);
}

//   θ  ɴϴ. 
// [Return ] True : , False : 
BOOL CSmartFTPWrap::GetCurrentDirectory(LPTSTR strPath)
{
	return m_pfGetCurrentDirectory(strPath);
}

//   ο   մϴ. 
// [Return ] True : , False : 
BOOL CSmartFTPWrap::CreateFolder(LPTSTR strFolderName)
{
	return m_pfCreateFolder(strFolderName);
}

//   ο   մϴ. 
// [Return ] True : , False : 
BOOL CSmartFTPWrap::DeleteFolder(LPTSTR strFolderName)
{
	return m_pfDeleteFolder(strFolderName);
}

//   ο   մϴ. 
// [Return ] True : , False : 
BOOL CSmartFTPWrap::DeleteFiles(LPTSTR strFileName)
{
	return m_pfDeleteFiles(strFileName);
}

//   ο Ǵ ̸  մϴ. 
// [Return ] True : , False : 
BOOL CSmartFTPWrap::ReName(LPTSTR strOldName, LPTSTR strNewName)
{
	return m_pfReName(strOldName, strNewName);
}

//    ٿε մϴ. Non-BlockingԼ ȣ ٷ  մϴ.
// GetPercentage() Լ    ٿε ¸ Ȯ  ֽϴ.
// [ ]
// LPTSTR strFTPFilePathName : FTP ٿε  ο ϸ
// LPTSTR strLocalFilePathName : ٿε Local  ο ̸
// [Return ] True : , False : 
BOOL CSmartFTPWrap::FileDownload(LPTSTR strFTPFilePathName, LPTSTR strLocalFilePathName)
{
	return m_pfFileDownload(strFTPFilePathName, strLocalFilePathName);
}

//    ε մϴ. Non-BlockingԼ ȣ ٷ  մϴ.
// GetPercentage() Լ    ε ¸ Ȯ  ֽϴ.
// [ ]
// LPTSTR strFTPFilePathName : FTP ε ο ϸ
// LPTSTR strLocalFilePathName : ε Local ο ̸
// [Return ] True : , False : 
BOOL CSmartFTPWrap::FileUpload(LPTSTR strLocalFilePathName, LPTSTR strFTPFilePathName)
{
	return m_pfFileUpload(strLocalFilePathName, strFTPFilePathName);
}

//    Ϲ Ʈ  ɴϴ.
// [ ]
// LPTSTR strRetList : Ϲ Ʈ    մϴ.
// "ϸ:\:ϸ:ϸ:ϸ:\:....."
//  迭 ũ 3000  Ͻñ ٶϴ.  ȣ  迭 ũ⸦ 3000 ҴϿ Ͻñ ٶϴ.
// [Return ] True : , False : 
BOOL CSmartFTPWrap::GetFileList(LPTSTR strRetList)
{
	return m_pfGetFileList(strRetList);
}

//  ٿε  ε  ¸ Ȯ մϴ.
// [Return ] 0~100% : , -1 : 
int CSmartFTPWrap::GetPercentage()
{
	return m_pfGetPercentage();
}

//  ٿε  ε   մϴ.
void CSmartFTPWrap::FileUpNDownloadCancel()
{
	m_pfFileUpNDownloadCancel();
}
